<template src="./template.html"></template>

<script lang="ts">
function sleep(milliseconds: number) {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      resolve(true);
    }, milliseconds);
  });
}
import { clone, cloneDeep } from "lodash";
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { regexEmail } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
var momentz = require("moment-timezone");
@Component({
  components: {},
})
export default class ManageSellersComponent extends Vue {
  @Prop()
  tab!: number;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };

  configEmail = {
    page: 1,
    limit: 25,
    search: "",
  };

  page = 1;

  listStatus = [
    {
      title: "All",
      value: 0,
    },
    {
      title: "Active",
      value: 1,
    },
    {
      title: "Deactive",
      value: 2,
    },
  ];
  status = 0;

  dialogAddAdmin = false;
  dialogViewDetail = false;
  loading = false;
  loadingTable = false;

  admin = {
    email: "",
    password: "",
    orderPrefix: "",
    code: "",
  };

  adminDetail = {
    _id: "",
    email: "",
    password: "",
    phoneNumber: "",
    name: "",
    supportEmail: "",
  };

  isTwofa = false;
  dateEndPicker = false;
  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  disabledButtonDate = false;
  get listAdmin() {
    const listAdmin = cloneDeep(this.$store.state.masterUsers.listAdmin);
    return listAdmin || [];
  }

  get totalPage() {
    return this.$store.state.masterUsers.totalPage || 0;
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  loadingStats = false;
  loadingStatsEmail = false;
  stats = {};
  statsEmail = {
    confirmFail: 0,
    confirmSuccess: 0,
    fulfillFail: 0,
    fulfillSuccess: 0,
  };

  async onGetStats() {
    try {
      this.loadingStats = true;
      this.stats = {};
      const response = await this.$api.stats.statsByTimeMaser({
        ...this.config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.stats = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingStats = false;
    }
  }

  async onGetStatsEmail() {
    try {
      this.loadingStatsEmail = true;
      const response = await this.$api.userMaster.email({
        ...this.configEmail,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { confirmFail, confirmSuccess, fulfillFail, fulfillSuccess } =
          response.data;

        this.statsEmail = {
          confirmFail,
          confirmSuccess,
          fulfillFail,
          fulfillSuccess,
        };
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingStatsEmail = false;
    }
  }
  confirmDialogResendEmail = false;

  async onResendMail() {
    try {
      this.loading = true;
      await this.$api.userMaster.resendMail();
      this.$pushNotification.success("Resend mail successfully!");
      this.confirmDialogResendEmail = false;
      this.onGetStatsEmail();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }
  get dateRangeText() {
    return this.dateArr.join("~");
  }
  currentDate = "";

  onSearchByDate() {
    if (this.dateRangeText.split("~").length < 2) {
      return this.$pushNotification.error("Please select 2 days or date range");
    }
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });

    this.onGetStats();
    this.onGetListUser();
    this.onGetStatsEmail();
    this.timeActive = "";
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  mounted() {
    this.onFilterByTime("Today");
    // this.onGetListUser();
    this.getCurrentDate();
  }
  getCurrentDate() {
    this.currentDate = momentz
      .tz(this.timezone)
      .format("hh:mm A DD MMM YYYY, z Z");
  }
  async onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.disabledButtonDate = true;
    const proms = [
      this.onGetStats(),
      this.onGetStatsEmail(),
      this.onGetListUser(),
    ];
    await Promise.all(proms);
    this.disabledButtonDate = false;
  }
  async onGetListUser() {
    try {
      this.loadingTable = true;
      const config: any = {
        ...this.config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      };
      if (this.status === 1) {
        config["isActive"] = true;
      } else if (this.status === 2) {
        config["isActive"] = false;
      } else {
        //@ts-ignore
        delete this.config.isActive;
      }
      await this.$store.dispatch("masterUsers/onGetListAdmin", {
        ctx: this,
        query: config,
      });
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogAddAdmin() {
    this.dialogAddAdmin = true;
    this.isTwofa = false;
    this.clearData();
  }

  closeDialogAddAdmin() {
    this.dialogAddAdmin = false;
  }

  async onAddAdmin() {
    try {
      if (!(this.admin.email || this.admin.password)) {
        return this.$pushNotification.error("Please enter full information");
      }
      if (!regexEmail.test(this.admin.email)) {
        return this.$pushNotification.error("Email invalid");
      }
      if (this.isTwofa) {
        if (!this.admin.code) {
          return this.$pushNotification.error("Please enter twofa");
        }
      }
      if (!this.admin.orderPrefix) {
        return this.$pushNotification.error(
          "Must enter order prefix information"
        );
      }
      await this.$api.userMaster.createAdmin(this.admin);
      this.$pushNotification.success("Create a successful admin");
      this.clearData();
      this.isTwofa = false;
      this.dialogAddAdmin = false;
      this.onGetListUser();
    } catch (error: any) {
      const message = error?.response?.data?.message || "";
      if (message === "MISSING_2FA") {
        this.isTwofa = true;
      }
      apiErrorHandler(error, this);
    }
  }

  openDialogViewDetail(admin: any) {
    this.adminDetail = admin;
    this.dialogViewDetail = true;
  }

  dialogEditUser = false;

  openDialogEditUser(admin: any) {
    this.adminDetail = admin;
    this.orderPrefix = admin.orderPrefix;
    this.dialogEditUser = true;
    this.twofa = "";
  }

  adminInfo: any = {};
  twofa = "";
  dialogConfirm = false;

  openDialogConfirm(admin: any) {
    if (admin) {
      this.adminInfo = admin;
      this.dialogConfirm = true;
      this.twofa = "";
      this.isTwofa = false;
    }
  }

  async closeDialogConfirm() {
    const findIndex = this.listAdmin.findIndex(
      (item: any) => item._id === this.adminInfo._id
    );
    this.loadingTable = true;
    this.listAdmin[findIndex].isActive = !this.listAdmin[findIndex].isActive;
    await sleep(10);
    this.loadingTable = false;
    this.dialogConfirm = false;
  }

  async onChangeStatus() {
    try {
      if (this.isTwofa && !this.twofa) {
        return this.$pushNotification.error("Please enter twofa");
      }
      this.loading = true;
      await this.$api.userMaster.changeStatus({
        adminId: this.adminInfo._id,
        isActive: this.adminInfo.isActive,
        code: this.twofa,
      });
      this.$pushNotification.success("Change status successfully");
      this.onGetListUser();
      this.dialogConfirm = false;
      this.twofa = "";
      this.isTwofa = false;
    } catch (error: any) {
      const message = error?.response?.data?.message || "";
      if (message === "MISSING_2FA") {
        this.isTwofa = true;
      }
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  orderPrefix = "";

  async AddPrefix() {
    try {
      if (this.isTwofa && !this.twofa) {
        return this.$pushNotification.error("Please enter twofa");
      }
      this.loading = true;
      await this.$api.userMaster.addPrefix({
        adminId: this.adminDetail._id,
        orderPrefix: this.orderPrefix,
        code: this.twofa,
      });
      this.$pushNotification.success("Update Order Prefix successfully");
      this.onGetListUser();
      this.dialogEditUser = false;
      this.isTwofa = false;
      this.twofa = "";
    } catch (error: any) {
      const message = error?.response?.data?.message || "";
      if (message === "MISSING_2FA") {
        this.isTwofa = true;
      }
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  clearData() {
    this.admin = {
      email: "",
      password: "",
      orderPrefix: "",
      code: "",
    };
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListUser();
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListUser();
  }

  @Watch("tab")
  changeTab(value: number) {
    if (value === 0) {
      this.onGetListUser();
    }
  }
}
</script>

<style lang="scss" scoped>
.form-resp {
  @media (max-width: 600px) {
    width: 100% !important;
  }
}
.column-box-shadow {
  box-shadow: 0px 1px 2px 0px rgba(0, 0, 0, 0.06),
    0px 1px 1px 0px rgba(0, 0, 0, 0.1),
    0px 0px 16px 0px rgba(63, 131, 248, 0.03) inset !important;
  border-bottom: 2px solid #e5e7eb;
}
</style>
